module cordic(clk, angle, sine, cosine);
parameter N = 20;
input clk;
input [N-1:0] angle;
output [N-1:0] sine, cosine;

wire [N-1:0] angles [15:0];

assign angles[0] = 77376;
assign angles[1] = 40884;
assign angles[2] = 20753;
assign angles[3] = 10417;
assign angles[4] = 5213;
assign angles[5] = 2607;
assign angles[6] = 1304;
assign angles[7] = 652;
assign angles[8] = 326;
assign angles[9] = 163;
assign angles[10] = 81;
assign angles[11] = 41;
assign angles[12] = 20;
assign angles[13] = 10;
assign angles[14] = 5;
assign angles[15] = 3;

reg [N-1:0] remainder [16:0] = '{default:0};
reg [N-1:0] x [16:0]         = '{default:0};
reg [N-1:0] y [16:0]         = '{default:0};

assign sine = x[15]   ;
assign cosine = y[15] ;


generate
    genvar i;
    for (i=0;i<=15;i=i+1) begin : ILOOP

    always @(posedge clk)
    begin
    if (remainder[i] < 0)
    begin
        remainder[i+1] <= remainder[i] + angles[i];
        x[i+1]   <= x[i] + {{i{y[i][N-1]}},y[i][N-1:i]};
        y[i+1]   <= y[i] - {{i{x[i][N-1]}},x[i][N-1:i]};
    end
    else
    begin
        remainder[i+1] <= remainder[i] - angles[i];
        x[i+1]   <= x[i] - {{i{y[i][N-1]}},y[i][N-1:i]};
        y[i+1]   <= y[i] + {{i{x[i][N-1]}},x[i][N-1:i]};
    end
    end
    end
endgenerate

always @(posedge clk)
begin
case (angle[N-1:N-2])
2'b00:
begin
x[0] <= 20'b01001001001111100000;
y[0] <= 20'b01001001001111100000;
remainder[0] <= angle - 20'b00110000110101000000;
end

2'b01:
begin
x[0] <= ~20'b01001001001111100000 + 1'b1;
y[0] <= 20'b01001001001111100000;
remainder[0] <= angle - 20'b00110000110101000000;
end

2'b10:
begin
x[0] <= ~20'b01001001001111100000 + 1'b1;
y[0] <= ~20'b01001001001111100000 + 1'b1;
remainder[0] <= angle - 20'hA0000;
end

2'b11:
begin
x[0] <= 20'b01001001001111100000;
y[0] <= ~20'b01001001001111100000 + 1'b1;
remainder[0] <= angle - 20'hE0000;
end
endcase

end
endmodule
