transcript on
if {[file exists work]} {
	vdel -lib work -all
}
vlib work
vmap work work

vlog -sv -work work {cordic.v}
vcom -93 -work work {sin_cos.vhd}
vlog -sv -work work {cordic_tb.v}

vsim -t 1ns -L work -voptargs="+acc"  cordic_tb


add wave -divider     "Angle/CLK/Out"
add wave -decimal     sim:/cordic_tb/DUT/angle
add wave -hexadecimal sim:/cordic_tb/DUT/clk

add wave -decimal -analog -min -525000 -max 525000 -height 50 sim:/cordic_tb/DUT/sine
add wave -decimal -analog -min -525000 -max 525000 -height 50 sim:/cordic_tb/DUT/cosine

add wave -divider     "Internals"
add wave -decimal      sim:/cordic_tb/DUT/remainder
add wave -decimal     {sim:/cordic_tb/DUT/remainder[0]}
add wave -decimal     {sim:/cordic_tb/DUT/remainder[1]}
add wave -decimal     {sim:/cordic_tb/DUT/remainder[2]}
add wave -decimal      sim:/cordic_tb/DUT/x
add wave -decimal     {sim:/cordic_tb/DUT/x[0]}
add wave -decimal     {sim:/cordic_tb/DUT/x[1]}
add wave -decimal     {sim:/cordic_tb/DUT/x[2]}
add wave -decimal      sim:/cordic_tb/DUT/y
add wave -decimal     {sim:/cordic_tb/DUT/y[0]}
add wave -decimal     {sim:/cordic_tb/DUT/y[1]}
add wave -decimal     {sim:/cordic_tb/DUT/y[2]}
add wave -divider     ""
add wave -divider     "VHDL Reference"

add wave -decimal -analog -min -525000 -max 525000 -height 50 sim:/cordic_tb/REFD/sine
add wave -decimal -analog -min -525000 -max 525000 -height 50 sim:/cordic_tb/REFD/cosine
add wave -decimal      sim:/cordic_tb/REFD/remainder
add wave -decimal     {sim:/cordic_tb/REFD/remainder[0]}
add wave -decimal     {sim:/cordic_tb/REFD/remainder[1]}
add wave -decimal     {sim:/cordic_tb/REFD/remainder[2]}
add wave -decimal      sim:/cordic_tb/REFD/x
add wave -decimal     {sim:/cordic_tb/REFD/x[0]}
add wave -decimal     {sim:/cordic_tb/REFD/x[1]}
add wave -decimal     {sim:/cordic_tb/REFD/x[2]}
add wave -decimal      sim:/cordic_tb/REFD/y
add wave -decimal     {sim:/cordic_tb/REFD/y[0]}
add wave -decimal     {sim:/cordic_tb/REFD/y[1]}
add wave -decimal     {sim:/cordic_tb/REFD/y[2]}


do run_cord.do
